<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:mpeg7="urn:mpeg:mpeg7:schema:2001" xmlns:xsi="http://www.w3.org/2000/10/XMLSchema-instance" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
  <conversion>
    <xsl:for-each select="//PresentationPriority/GeneralResourcePriorities/ModalityPriorities/Modality">
    <xsl:sort select="@priorityLevel" />
    <xsl:if test="mpeg7:Name = 'Video'">
    <command id="video">
      -y -s <xsl:value-of select="//UsageEnvironment/TerminalCapabilities/Display/Resolution/@horisontal"></xsl:value-of>x<xsl:value-of select="//UsageEnvironment/TerminalCapabilities/Display/Resolution/@vertical"></xsl:value-of> -r <xsl:value-of select="//UsageEnvironment/TerminalCapabilities/Display/@refreshRate"></xsl:value-of> -vcodec <xsl:value-of select="//UsageEnvironment/TerminalCapabilities/Decoding[@xsi:type='VideoCapabilitiesType']/Format/mpeg7:Name"></xsl:value-of> -b <xsl:value-of select="//UsageEnvironment/NetworkCharacteristics/@minGuaranteed"></xsl:value-of>
    </command>
    </xsl:if>
    <xsl:if test="mpeg7:Name = 'Audio'">
    <command id="audio">
      -y -ar <xsl:value-of select="//AudioOut/@samplingFrequency"></xsl:value-of> -ac <xsl:value-of select="//AudioOut/@numChannels"></xsl:value-of> -acodec <xsl:value-of select="//UsageEnvironment/TerminalCapabilities/Decoding[@xsi:type='AudioCapabilitiesType']/Format/mpeg7:Name"></xsl:value-of>
    </command>
    </xsl:if>
    </xsl:for-each>
  </conversion>
  </xsl:template>
</xsl:stylesheet>
