<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:didl="urn:mpeg:mpeg21:2002:01-DIDL-NS" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:template match="/">
     <html xmlns:time="urn:schemas-microsoft-com:time">
      <head>
        <xsl:text disable-output-escaping="yes">
          &lt;?import namespace="time" implementation="#default#time2"&gt;
        </xsl:text>
        <style>
           .time {behavior: url(#default#time2)}
        </style>
        <script type="text/javascript">
          var file_names = new Array(
              <xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>"
                  </xsl:when>
                  <xsl:otherwise>
                    "<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>",               </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
              )
          var durations = new Array(
             <xsl:for-each select="//didl:ANCHOR">
              <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                <xsl:choose>
                  <xsl:when test="position()=last()">
                    <xsl:value-of select="@FRAGMENT"></xsl:value-of>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="@FRAGMENT"></xsl:value-of>,
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
              )
          <xsl:text disable-output-escaping="yes">
            var len = durations.length
            var t_start
            var sync
            var current
            var slidetime
            var elapsed
            var paused = 0
            var t_paused = 0
            var total_paused = 0
            var count = 1
		function popUp(URL) {
		day = new Date();
		id = day.getTime();
		eval("page" + id + " = window.open(URL, '" + id + "', 'toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=500,height=800,left = 490,top = 362');");
	        }
            function init()
            {
              var t = new Date()
              t_start = t.getTime()
              current = 1
              sync = 1
              startTimer()
            }
            function startTimer()
            {
              if (sync==0)
              {
                slidetime=0
                for (i=0; i&lt;current-1; i++)
                  {slidetime +=durations[i]}
                var t=new Date()
                elapsed=t.getTime()-t_start-total_paused
                if (elapsed&gt;slidetime &amp;&amp; elapsed&lt;slidetime+ durations[current-1])
                {
                  moveToBack()
                  sync=1
                }
              }
              timer=setTimeout("startTimer()", 10)
            }
            function stopTimer()
            {
              clearTimeout("timer")
            }
            function moveToFront()
            {
              document.getElementById('image').style.zIndex = "1"
            }
            function moveToBack()
            {
              document.getElementById('image').style.zIndex = "-1"
            }
            function changeSlide()
            {
              document.getElementById('image').src = file_names[current-1]
            }
            function showFirst()
            {
              current=1
              moveToFront()
              changeSlide()
              sync=0
            }
            function showLast()
            {
              current=len
              moveToFront()
              changeSlide()
              sync=0
            }
            function findNext(t_elapsed)
            {
              var i=0
              var last= len -1
              var total=0
              while (i&lt;last)
              {
                total+=durations[i]
                if (t_elapsed&lt;total)
                {
                  return i+2
                }
                i++
              }
              return last+1
            }
            function showNext()
            {
             if (sync==1 &amp;&amp; paused==0)
             {
              var t = new Date()
              var t_click = t.getTime()
              var t_elapsed = t_click - t_start - total_paused
              current = findNext(t_elapsed)
              moveToFront()
              changeSlide()
              sync=0
             }
             else if (paused==1 &amp;&amp; count==1)
             {
              var t_elapsed = t_paused - t_start - total_paused
              current = findNext(t_elapsed)
              moveToFront()
              changeSlide()
              count=2
             }
             else
             {
              if (current&lt;5)
              {
               current++
               changeSlide()
              }
             }
            }
            function findPrev(t_elapsed)
            {
             var i=start-1
             var last= len-1
             var total=0
             for (i; i&lt;=last; i++)
             {
              total+=durations[i]
             }
             var finish=start-1
             i=last
             while (i&gt;finish)
             {
              total-= durations[i]
              if (t_elapsed&gt;total)
              {
               return i
              }
              i--
             }
             return 1
            }
            function showPrev()
            {
             if (sync==1 &amp;&amp; paused==0)
             {
              var t = new Date()
              var t_click = t.getTime()
              var t_elapsed = t_click - t_start - total_paused
              current = findPrev(t_elapsed)
              moveToFront()
              changeSlide()
              sync=0
             }
             else if (paused==1 &amp;&amp; count==1)
             {
              var t_elapsed = t_paused - t_start - total_paused
              current = findPrev(t_elapsed)
              moveToFront()
              changeSlide()
              count=2
             }
             else
             {
              if (current&gt;1)
              {
               current--
               changeSlide()
              }
             }
            }
           function showSlide(num)
           {
            current=num
            moveToFront()
            changeSlide()
            sync=0
           }
           function pauseResume()
           {
            if (paused==0)
            {
             movie.pauseElement()
             slides.pauseElement()
             var t = new Date()
             t_paused = t.getTime()
             paused = 1
            }
            else
            {
             movie.resumeElement()
             slides.resumeElement()
             var t = new Date()
             total_paused += t.getTime()-t_paused
             moveToBack()
             paused = 0
             count = 1
            }
           }
           function noPause()
           {
            form1.pauseBtn.disabled = true
           }
          </xsl:text>
        </script>
        <style>
          body {background-color:ivory; margin-left:0px; margin-top:0px; margin-bottom:0px}
        </style>
        <title>Active</title>
      </head>
      <body onunload="stopTimer()">  <time:par>
        <table border="0" height="100%" width="100%">
          <tr>
            <td align="center" bgcolor="lightgrey" rowspan="5" valign="top" width="1%">
              <img>
                <xsl:attribute name="src">
                  <xsl:value-of select="//didl:DESCRIPTOR[@ID='LOGO']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                </xsl:attribute>
              </img>
              <time:video clipBegin="0s" dur="15s" id="movie" onEnd="noPause()" repeatCount="1" style="border:solid; color:gray; border-width:5px">
                     <xsl:attribute name="src">
                       <xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='VIDEO']/didl:RESOURCE/@REF"></xsl:value-of>
                     </xsl:attribute>
                     <xsl:attribute name="type">
                       <xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='VIDEO']/didl:DESCRIPTOR[@ID='VIDEO_FORMAT']/didl:STATEMENT"></xsl:value-of>
                     </xsl:attribute>
              </time:video>
              <time:audio clipBegin="0s" dur="15s" id="sound" repeatCount="1">
                     <xsl:attribute name="src">
                       <xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='AUDIO']/didl:RESOURCE/@REF"></xsl:value-of>
                     </xsl:attribute>
                     <xsl:attribute name="type">
                       <xsl:value-of select="//didl:ITEM[@ID='1']/didl:COMPONENT[@ID='AUDIO']/didl:DESCRIPTOR[@ID='AUDIO_FORMAT']/didl:STATEMENT"></xsl:value-of>
                     </xsl:attribute>
              </time:audio>
              <form action="view.jsp" id="form1" method="post">
                    <input id="pauseBtn" onclick="pauseResume()" type="button" value="Play/Pause"></input>
                    <input name="submit" type="submit" value="Restart"></input>
              </form>
              <div style="overflow-y:scroll; width:120px; height:200px">
                <xsl:for-each select="//didl:ANCHOR">
                  <input name="slide" onFocus="showSlide(1)" type="radio" value="1">
                    <xsl:attribute name="onFocus">
                      showSlide(<xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:value-of>)
                    </xsl:attribute>
                         Chapter <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:value-of>
                  </input><br />
                </xsl:for-each>
              </div>
            </td>
            <td align="center" rowspan="4">
              <table border="1" width="420">
                <tr align="left">
                  <td>
                    <img id="image" style="position:absolute; z-index:-1;" width="420">
                      <xsl:attribute name="src">
                        <xsl:for-each select="//didl:ANCHOR">
                            <xsl:if test="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT = 1">
                              <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                            </xsl:if>
                          </xsl:for-each>
                      </xsl:attribute>
                    </img>
                    <time:seq id="slides" repeatCount="1">.
                          <xsl:for-each select="//didl:ITEM/didl:COMPONENT[@ID='SLIDES']/didl:ANCHOR">
                            <xsl:sort select="didl:DESCRIPTOR[@ID='SLIDE_NUMBER']/didl:STATEMENT"></xsl:sort>
                            <img class="time" style="width:420px">
                            <xsl:attribute name="src">
                              <xsl:value-of select="didl:DESCRIPTOR[@ID='SLIDE_LOCATION']/didl:COMPONENT/didl:RESOURCE/@REF"></xsl:value-of>
                            </xsl:attribute>
			    <xsl:if test="position() = last()">
				<xsl:attribute name="dur">indefinite</xsl:attribute>
			    </xsl:if>
			    <xsl:if test="position() != last()">
                            <xsl:attribute name="dur">
                              <xsl:value-of select="@FRAGMENT"></xsl:value-of>
                            </xsl:attribute>
			    </xsl:if>
                            </img>
                          </xsl:for-each>
                    </time:seq>
                  </td>
                </tr>
              </table>
            </td>
            <td align="center"><input onclick="showFirst()" type="button" value="First"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showPrev()" type="button" value="Prev"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showNext()" type="button" value="Next"></input></td>
          </tr>
          <tr>
            <td align="center"><input onclick="showLast()" type="button" value="Last"></input></td>
          </tr>
          <tr>
            <td colspan="2"><iframe src="textchat.html" width="100%"></iframe></td>
          </tr>
        </table>
        </time:par>
      </body>
    </html>
  </xsl:template>
</xsl:stylesheet>
